function mdl=ind_init(mdl)
%nx=mdl.NXi;
ny=mdl.NYi;
nz=mdl.NZi;
NX=mdl.NX;
NY=mdl.NY;
NZ=mdl.NZ;
Lx=mdl.Lx_OBi+mdl.Lx_OBo+mdl.Lx_pml;
Ly=mdl.Ly_OBi+mdl.Ly_OBo+mdl.Ly_pml;
Lz=mdl.Lz_OBi+mdl.Lz_OBo+mdl.Lz_pml;
Ip=mdl.Ip;
Jp=mdl.Jp;
Kp=mdl.Kp;
%
mdl.tEx=cat(1,zeros(Lx(1),ny,nz),mdl.tEx,zeros(Lx(2)+1,ny,nz));
mdl.tEx=cat(2,zeros(NX,Ly(1),nz),mdl.tEx,zeros(NX,Ly(2),nz));
mdl.tEx=cat(3,zeros(NX,NY,Lz(1)),mdl.tEx,zeros(NX,NY,Lz(2)));
mdl.tEx(1:Ip(1)-1,:,:)=-2; % PML
mdl.tEx(Ip(2):NX-1,:,:)=-2;
mdl.tEx(:,2:Jp(1)-1,:)=-2;
mdl.tEx(:,Jp(2)+1:NY-1,:)=-2;
mdl.tEx(:,:,2:Kp(1)-1)=-2;
mdl.tEx(:,:,Kp(2)+1:NZ-1)=-2;
mdl.tEx(NX,:,:)=-1;	% PEC
mdl.tEx(:,1,:)=-1;
mdl.tEx(:,NY,:)=-1;
mdl.tEx(:,:,1)=-1;
mdl.tEx(:,:,NZ)=-1;
%
mdl.tEy=cat(1,zeros(Lx(1),ny-1,nz),mdl.tEy,zeros(Lx(2),ny-1,nz));
mdl.tEy=cat(2,zeros(NX,Ly(1),nz),mdl.tEy,zeros(NX,Ly(2)+1,nz));
mdl.tEy=cat(3,zeros(NX,NY,Lz(1)),mdl.tEy,zeros(NX,NY,Lz(2)));
mdl.tEy(2:Ip(1)-1,:,:)=-2;
mdl.tEy(Ip(2)+1:NX-1,:,:)=-2;
mdl.tEy(:,1:Jp(1)-1,:)=-2;
mdl.tEy(:,Jp(2):NY-1,:)=-2;
mdl.tEy(:,:,2:Kp(1)-1)=-2;
mdl.tEy(:,:,Kp(2)+1:NZ-1)=-2;
mdl.tEy(1,:,:)=-1;
mdl.tEy(NX,:,:)=-1;
mdl.tEy(:,NY,:)=-1;
mdl.tEy(:,:,1)=-1;
mdl.tEy(:,:,NZ)=-1;
%
mdl.tEz=cat(1,zeros(Lx(1),ny,nz-1),mdl.tEz,zeros(Lx(2),ny,nz-1));
mdl.tEz=cat(2,zeros(NX,Ly(1),nz-1),mdl.tEz,zeros(NX,Ly(2),nz-1));
mdl.tEz=cat(3,zeros(NX,NY,Lz(1)),mdl.tEz,zeros(NX,NY,Lz(2)+1));
mdl.tEz(2:Ip(1)-1,:,:)=-2;
mdl.tEz(Ip(2)+1:NX-1,:,:)=-2;
mdl.tEz(:,2:Jp(1)-1,:)=-2;
mdl.tEz(:,Jp(2)+1:NY-1,:)=-2;
mdl.tEz(:,:,1:Kp(1)-1)=-2;
mdl.tEz(:,:,Kp(2):NZ-1)=-2;
mdl.tEz(1,:,:)=-1;
mdl.tEz(NX,:,:)=-1;
mdl.tEz(:,1,:)=-1;
mdl.tEz(:,NY,:)=-1;
mdl.tEz(:,:,NZ)=-1;
%
mdl.tHx=cat(1,zeros(Lx(1),ny-1,nz-1),mdl.tHx,zeros(Lx(2),ny-1,nz-1));
mdl.tHx=cat(2,zeros(NX,Ly(1),nz-1),mdl.tHx,zeros(NX,Ly(2)+1,nz-1));
mdl.tHx=cat(3,zeros(NX,NY,Lz(1)),mdl.tHx,zeros(NX,NY,Lz(2)+1));
mdl.tHx(2:Ip(1)-1,:,:)=-2;
mdl.tHx(Ip(2)+1:NX-1,:,:)=-2;
mdl.tHx(:,1:Jp(1)-1,:)=-2;
mdl.tHx(:,Jp(2):NY-1,:)=-2;
mdl.tHx(:,:,1:Kp(1)-1)=-2;
mdl.tHx(:,:,Kp(2):NZ-1)=-2;
mdl.tHx(1,:,:)=-1;
mdl.tHx(NX,:,:)=-1;
mdl.tHx(:,NY,:)=-1;
mdl.tHx(:,:,NZ)=-1;
%
mdl.tHy=cat(1,zeros(Lx(1),ny,nz-1),mdl.tHy,zeros(Lx(2)+1,ny,nz-1));
mdl.tHy=cat(2,zeros(NX,Ly(1),nz-1),mdl.tHy,zeros(NX,Ly(2),nz-1));
mdl.tHy=cat(3,zeros(NX,NY,Lz(1)),mdl.tHy,zeros(NX,NY,Lz(2)+1));
mdl.tHy(1:Ip(1)-1,:,:)=-2;
mdl.tHy(Ip(2):NX-1,:,:)=-2;
mdl.tHy(:,2:Jp(1)-1,:)=-2;
mdl.tHy(:,Jp(2)+1:NY-1,:)=-2;
mdl.tHy(:,:,1:Kp(1)-1)=-2;
mdl.tHy(:,:,Kp(2):NZ-1)=-2;
mdl.tHy(NX,:,:)=-1;
mdl.tHy(:,1,:)=-1;
mdl.tHy(:,NY,:)=-1;
mdl.tHy(:,:,NZ)=-1;
%
mdl.tHz=cat(1,zeros(Lx(1),ny-1,nz),mdl.tHz,zeros(Lx(2)+1,ny-1,nz));
mdl.tHz=cat(2,zeros(NX,Ly(1),nz),mdl.tHz,zeros(NX,Ly(2)+1,nz));
mdl.tHz=cat(3,zeros(NX,NY,Lz(1)),mdl.tHz,zeros(NX,NY,Lz(2)));
mdl.tHz(1:Ip(1)-1,:,:)=-2;
mdl.tHz(Ip(2):NX-1,:,:)=-2;
mdl.tHz(:,1:Jp(1)-1,:)=-2;
mdl.tHz(:,Jp(2):NY-1,:)=-2;
mdl.tHz(:,:,2:Kp(1)-1)=-2;
mdl.tHz(:,:,Kp(2)+1:NZ-1)=-2;
mdl.tHz(NX,:,:)=-1;
mdl.tHz(:,NY,:)=-1;
mdl.tHz(:,:,1)=-1;
mdl.tHz(:,:,NZ)=-1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:mdl.Nmedium
    mdl.iEx{n}=find(mdl.tEx==n-1);
    mdl.iEy{n}=find(mdl.tEy==n-1);
    mdl.iEz{n}=find(mdl.tEz==n-1);
end
mdl.p_iEx=find(mdl.tEx==-2);
mdl.p_iEy=find(mdl.tEy==-2);
mdl.p_iEz=find(mdl.tEz==-2);
mdl=rmfield(mdl,{'tEx','tEy','tEz'});
%
for n=1:mdl.Nmedium
    mdl.iHx{n}=find(mdl.tHx==n-1);
    mdl.iHy{n}=find(mdl.tHy==n-1);
    mdl.iHz{n}=find(mdl.tHz==n-1);
end
mdl.p_iHx=find(mdl.tHx==-2);
mdl.p_iHy=find(mdl.tHy==-2);
mdl.p_iHz=find(mdl.tHz==-2);
mdl=rmfield(mdl,{'tHx','tHy','tHz'});
end