function C=Christoffel_sw_cart(X,Rs)
% X=[x;y;z]
R=norm(X);
r=0.25*Rs/R;
dg00_R=-Rs*(1-r)/((1+r)*R)^3;
dgii_R=-Rs*((1+r)/R)^3;
dg=zeros(4,4,4);
dg(1,1,2:4)=dg00_R*reshape(X,1,1,3);
dg(2,2,2:4)=dgii_R*reshape(X,1,1,3);
dg(3,3,2:4)=dg(2,2,2:4);
dg(4,4,2:4)=dg(2,2,2:4);
C=0.5*(dg+ipermute(dg,[3 1 2])-ipermute(dg,[2 3 1]));
gi=diag([-((1+r)/(1-r))^2,repmat(1/(1+r)^4,1,3)]);
C=dot_TT(gi,2,C,1);
end