function U_uu=Int_U_uu(Rs,lamda1,r,u,Su_u,Su_uu,Su_uuu,U,U_u,sv)
U_uu=-0.5*Riemann_sw(Rs,r(1),pi/2);
U_uu=sv(@(lamda,U_uu) equ_U_uu(lamda,U_uu,Rs,lamda1,r,u,Su_u,Su_uu,Su_uuu,U,U_u),U_uu(:));
end
%
function dU=equ_U_uu(lamda,U_uu,Rs,lamda1,r,u,Su_u,Su_uu,Su_uuu,U,U_u)
r=interp1(lamda1,r,lamda,'spline');
u=interp1(lamda1,u.',lamda,'spline').';
C=Christoffel_sw(Rs,r,pi/2);
R=Riemann_sw(Rs,r,pi/2);
R1=RM1_sw(Rs,r,pi/2);
a=inv_metric_sw(Rs,r,pi/2);
Rm=dot_TT(a,2,R,1);
Rm1=dot_TT(a,2,R1,1);
Su_uu=reshape(interp1(Su_uu.x,Su_uu.y.',lamda,'spline'),4,4,4);
U =reshape(interp1(U.x,  U.y.',lamda,'spline'),4,4);
U_u=reshape(interp1(U_u.x,U_u.y.',lamda,'spline'),4,4,4);
U_uu=reshape(U_uu,4,4,4,4);
%%%%
dU=dot_TV(ipermute(dot_TT(C,1,U_uu,1),[1 5 2 3 4])...
         +ipermute(dot_TT(U_uu,3,C,1),[1 2 4 3 5])...
         +dot_TT(U_uu,4,C,1),5,u);
a=dot_TT(Rm1,1,U,1);
b=dot_TT(Rm,1,U_u,1);
c=dot_TT(U_u,3,Rm,1);
dU=dU-dot_TV(ipermute(a,[1 5 3 4 2])...
            +ipermute(b,[1 5 4 2 3])...
            +ipermute(b,[1 5 3 2 4])...
            +ipermute(c,[1 2 3 5 4]),5,u);
if(lamda==0)
    dU=dU-L0_U2s2Us4(R1,u);
else
    Su_u=reshape(interp1(Su_u.x,Su_u.y.',lamda,'spline'),4,4);
    Su_uuu=reshape(interp1(Su_uuu.x,Su_uuu.y.',lamda,'spline'),4,4,4,4);
    %
    a=dot_TT(U_uu,3,Su_u,1);
    b=prod_tensor(U,Contraction(Su_uuu,1,2));
    %
    dU=dU-(a+ipermute(a,[1 2 4 3])+0.5*b)/lamda;
    %
    a=dot_TT(U_u,3,Su_uu,1);
    b=0.5*prod_tensor(U_u,Contraction(Su_uu,1,2));
    c=0.5*(trace(Su_u)-4)*U_uu;
    %
    dU=dU-(a+b+ipermute(b,[1 2 4 3])+c)/lamda;
end
dU=dU(:);
end
%
function s=L0_U2s2Us4(R1,u)
a=ipermute(R1,[1 2 3 5 4])+ipermute(R1,[1 2 4 5 3]);
s=-dot_TV(a,5,u)/3;
end