function V0=Int_V0(Rs,lamda1,r,u,Su_u,U2,sv)
V0=sv(@(lamda,V0) equ_V0(lamda,V0,Rs,lamda1,r,u,Su_u,U2),zeros(16,1));
end
%
function dV=equ_V0(lamda,V0,Rs,lamda1,r,u,Su_u,U2)
r=interp1(lamda1,r,lamda,'spline');
u=interp1(lamda1,u.',lamda,'spline').';
C=Christoffel_sw(Rs,r,pi/2);
V0=reshape(V0,4,4);
%%%%
dV=dot_TV(dot_TT(C,1,V0,1),2,u);
if(lamda==0)
    Rm1=dot_TT(inv_metric_sw(Rs,r,pi/2),2,RM1_sw(Rs,r,pi/2),1);
    dV=dV-L0_V0U(Rm1,u);
else
    Su_u=reshape(interp1(Su_u.x,Su_u.y.',lamda,'spline'),4,4);
    U2=reshape(interp1(U2.x,U2.y.',lamda,'spline'),4,4);
    dV=dV-0.5*((trace(Su_u)-2)*V0-U2)/lamda;
end
dV=dV(:);
end
%
function s=L0_V0U(Rm1,u)
Rm1=Contraction(Rm1,1,5);
s=dot_TV(Rm1,1,u)/12;
end