function C=dot_TT(A,a,B,b)
% C(i1,i2,...,ia-1,ia+1,...,im,j1,j2,...,jb-1,jb+1,...,jn)
%   =sum(A(i1,i2,...,ia-1,is,ia+1,...,im)*B(j1,j2,...,jb-1,is,jb+1,...,jn),is)
da=ndims(A);
if(a>da)
    error('dot_TT error, a > ndims(A) !');
end
db=ndims(B);
if(b>db)
    error('dot_TT error, b > ndims(B) !');
end
Na=4^(da-1);
Nb=4^(db-1);
A=shiftdim(A,a);
B=shiftdim(B,b);
C=zeros(repmat(4,1,da+db-2));
if(da==2)
    sa=[1 4];
else
    sa=repmat(4,1,da-1);
end
if(db==2)
    sb=[1 4];
else
    sb=repmat(4,1,db-1);
end
for i=1:4
    C=C+prod_tensor(shiftdim(reshape(A(((i-1)*Na+1):i*Na),sa),da-a),...
                    shiftdim(reshape(B(((i-1)*Nb+1):i*Nb),sb),db-b));
end
end