function em=med_bound(mdl,sw,i,fi,j,fj,k,fk)
Ip=mdl.Ip;
Jp=mdl.Jp;
Kp=mdl.Kp;
em=ones(size(i));
%
fxb{1}=i<Ip(1);
if(fi)
    fx=i>=Ip(1)&i<=Ip(2);
    fxb{2}=i>Ip(2);
else
    fx=i>=Ip(1)&i<Ip(2);
    fxb{2}=i>=Ip(2);
end
%
fyb{1}=j<Jp(1);
if(fj)
    fy=j>=Jp(1)&j<=Jp(2);
    fyb{2}=j>Jp(2);
else
    fy=j>=Jp(1)&j<Jp(2);
    fyb{2}=j>=Jp(2);
end
%
fzb{1}=k<Kp(1);
if(fk)
    fz=k>=Kp(1)&k<=Kp(2);
    fzb{2}=k>Kp(2);
else
    fz=k>=Kp(1)&k<Kp(2);
    fzb{2}=k>=Kp(2);
end
% x
f1=fy&fz;
for s1=1:2
    f=fxb{s1}&f1;
    x=repmat(mdl.x(Ip(s1)),sum(f),1);
    if(fj)
        y=mdl.y(j(f));
    else
        y=(mdl.y(j(f))+mdl.y(j(f)+1))/2;
    end
    if(fk)
        z=mdl.z(k(f));
    else
        z=(mdl.z(k(f))+mdl.z(k(f)+1))/2;
    end
    em(f)=epsrmur_sw(x,y,z,sw);
end
% y
f1=fx&fz;
for s2=1:2
    f=fyb{s2}&f1;
    if(fi)
        x=mdl.x(i(f));
    else
        x=(mdl.x(i(f))+mdl.x(i(f)+1))/2;
    end
    y=repmat(mdl.y(Jp(s2)),sum(f),1);
    if(fk)
        z=mdl.z(k(f));
    else
        z=(mdl.z(k(f))+mdl.z(k(f)+1))/2;
    end
    em(f)=epsrmur_sw(x,y,z,sw);
end
% z
f1=fx&fy;
for s3=1:2
    f=fzb{s3}&f1;
    if(fi)
        x=mdl.x(i(f));
    else
        x=(mdl.x(i(f))+mdl.x(i(f)+1))/2;
    end
    if(fj)
        y=mdl.y(j(f));
    else
        y=(mdl.y(j(f))+mdl.y(j(f)+1))/2;
    end
    z=repmat(mdl.z(Kp(s3)),sum(f),1);
    em(f)=epsrmur_sw(x,y,z,sw);
end
% y z
for s3=1:2
    for s2=1:2
        f=fx&fyb{s2}&fzb{s3};
        L=sum(f);
        if(fi)
            x=mdl.x(i(f));
        else
            x=(mdl.x(i(f))+mdl.x(i(f)+1))/2;
        end
        y=repmat(mdl.y(Jp(s2)),L,1);
        z=repmat(mdl.z(Kp(s3)),L,1);
        em(f)=epsrmur_sw(x,y,z,sw);
    end
end
% x z
for s3=1:2
    for s1=1:2
        f=fxb{s1}&fy&fzb{s3};
        L=sum(f);
        x=repmat(mdl.x(Ip(s1)),L,1);
        if(fj)
            y=mdl.y(j(f));
        else
            y=(mdl.y(j(f))+mdl.y(j(f)+1))/2;
        end
        z=repmat(mdl.z(Kp(s3)),L,1);
        em(f)=epsrmur_sw(x,y,z,sw);
    end
end
% x y
for s2=1:2
    for s1=1:2
        f=fxb{s1}&fyb{s2}&fz;
        L=sum(f);
        x=repmat(mdl.x(Ip(s1)),L,1);
        y=repmat(mdl.y(Jp(s2)),L,1);
        if(fk)
            z=mdl.z(k(f));
        else
            z=(mdl.z(k(f))+mdl.z(k(f)+1))/2;
        end
        em(f)=epsrmur_sw(x,y,z,sw);
    end
end
% x y z
for s3=1:2
    for s2=1:2
        for s1=1:2
            f=fxb{s1}&fyb{s2}&fzb{s3};
            x=mdl.x(Ip(s1));
            y=mdl.y(Jp(s2));
            z=mdl.z(Kp(s3));
            em(f)=epsrmur_sw(x,y,z,sw);
        end
    end
end
end