function s=wave_fun(t,wave)
switch wave.type
    case 'SINE'
        s=wave.A*sin(wave.omg*t);
        ft_5=wave.F*t/5;
        if(ft_5<1)
            s=s*(1-cos(pi*ft_5))/2;
        end
    case 'GAUSS'
        s=wave.A*exp(-0.5*(t/wave.sgm-4)^2);
    case 'DIFFGAUSS'
        s=wave.A*exp(0.5)*(t/wave.sgm-4)*exp(-0.5*(t/wave.sgm-4)^2);
    case 'MODGAUSS'
        s=wave.A*exp(-0.5*(t/wave.sgm-4)^2)*cos(wave.omg0*t);
    otherwise
        error(['wave type ' wave.type ' is not defined.']);
end
end